/**
 * Reverse Anchor (30rvsanchor.js)
 * 
 * \author ultraist
 * \date 2006-01-18
 */

initFunc[initFunc.length] = function() {
    // initialize
    var reply = new Array();
    var records = document.getElementById('records');
    if (! records) {
        return;
    }
    
    
    var anc = records.getElementsByTagName('a');
    for (var i=0; i<anc.length; i++) {
        if (anc[i].className == 'innerlink' 
            && anc[i].href.search(/([0-9a-f]{8})/) > 0) 
        {
            var id = RegExp.$1;
            var id_array    = new Array(1);
            id_array[0]     = id;
            
            var parent_id = anc[i].parentNode.id;
            if (parent_id) {
                parent_id = parent_id.replace(/^b/, "");
                
                if (reply[id] == undefined) {
                    reply[id] = new Array();
                }
                if (hasId(reply[id], parent_id)) {
	                reply[id][reply[id].length] = parent_id;
	            }
            }
        }
    }
    
    for (var to in reply) {
        var a = document.getElementById('i' + to);
        if (a && reply[to]) {
            var id_array = new Array();
            var index = 0;
            for (var i = 0; i < reply[to].length; ++i) {
                id_array[index++] = reply[to][i];
            }
            if (id_array.length > 0) {
                // フォーマットはここ変える
                a.innerHTML += ':<span class="rvsanc">(<span class="rvsancno">' 
                                + id_array.length + '</span>)</span>';
                
                if (a.addEventListener) {
                    a.addEventListener(
                        'mouseover',
                        (function (_id) {
                            return function(event) {popupReverseAnchor(event, _id);}
                        })(id_array),
                        false);
                    a.addEventListener('mouseout', hidePopup, false);
                } else if (a.attachEvent) {
                    a.attachEvent(
                        'onmouseover',
                        (function (_id) {
                            return function () {popupReverseAnchor(null, _id);}
                        })(id_array));
                    a.attachEvent('onmouseout', hidePopup);
                }
            }
        }
    }
    
    
    // handlers
    
    function popupReverseAnchor(e, aid) {
        var coordinate = new Coordinate(e);
        var dl = document.createElement('dl');
        
        for (var i = 0; i < aid.length; ++i) {
            var dt = document.getElementById("r" + aid[i]);
            var dd = document.getElementById("b" + aid[i]);
            if (dt && dd) {
                dt = dt.innerHTML;
                var re = new RegExp("</?(input|a)[^<>]*>", "ig");
                dt = dt.replace(re, "");
                
                dd = dd.innerHTML;
                re = new RegExp("(<br[^<>]*>\\s*)*$", "i");
                dd = dd.replace(re, "");
                
                dl.innerHTML += '<dt>' + dt + '</dt><dd>' + dd + '</dd>';
            }
        }
        showPopup(coordinate, [dl]);
    }
    
    function hasId(array, id)
    {
    	for (var i in array) {
    		if (array[i] == id) {
    			return false;
    		}
    	}
    	return true;
    }
};

















